/********************************** (C) COPYRIGHT *******************************
* File Name          : Udisk_Func_BasicOp.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2022/11/22
* Description        : USB full-speed port host operation functions.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*******************************************************************************/
/* Header File */
#include "Udisk_Operation.h"

/*******************************************************************************/
/* Variable Definition */
__attribute__((aligned(4)))  uint8_t  MY_DATA_BUF[ DISK_BASE_BUF_LEN ];   /* MY_DATA_BUFָⲿRAMĴݻ,Ϊһĳ,ûݻ */
uint8_t  *pCodeStr;

/*********************************************************************
 * @fn      UDisk_USBH_ByteOperation
 *
 * @brief   Demo Function For UDisk File Byte-operation
 *          including Create\Modify\Read\Erase (EXAM1)
 *
 * @return  none
 */
void UDisk_USBH_ByteOperation( void )
{
    uint8_t  c, s, i;
    uint16_t TotalCount = 0;

   UDisk_USBH_DiskReady( );
    if( ( CH103DiskStatus >= DISK_MOUNTED )&&( UDisk_Opeation_Flag == 1 ) )
    {
        UDisk_Opeation_Flag = 0;
        printf("CH103DiskStatus:%02x\r\n", CH103DiskStatus);
        /* ļ */
        strcpy((char *)mCmdParam.Open.mPathName, "/C51/NEWFILE.C");         //ýҪļ·ļ/NEWFILE.C
        s = CH103FileOpen();                                               //ļ
        if(s == ERR_MISS_DIR || s == ERR_MISS_FILE)                        //ûҵļ
        {
            //ļʾ
            printf("Find No File And Create\r\n");
            strcpy((char *)mCmdParam.Create.mPathName, "/NEWFILE.C");       //ļ,ڸĿ¼,ļ
            s = CH103FileCreate();                                         //½ļ,ļѾɾ½
            mStopIfError(s);
            printf("ByteWrite\r\n");
            //ʵӦждݳȺͶ建ǷڻҪд
            i = sprintf((char *)Com_Buffer, "Note: \xd\xaֽΪλUļд,ʾܡ\xd\xa"); //ʾ
            for(c = 0; c < 10; c++)
            {
                mCmdParam.ByteWrite.mByteCount = i;                          //ָдֽ
                mCmdParam.ByteWrite.mByteBuffer = Com_Buffer;                       //ָ򻺳
                s = CH103ByteWrite();                                        //ֽΪλļд
                mStopIfError(s);
                printf("WriteIn Success %02X times\r\n", (uint16_t)c);
            }
            //ʾ޸ļ
            printf("Modify\r\n");
            mCmdParam.Modify.mFileAttr = 0xff;                               //: µļ,Ϊ0FFH޸
            mCmdParam.Modify.mFileTime = 0xffff;                             //: µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
            mCmdParam.Modify.mFileDate = MAKE_FILE_DATE(2015, 5, 18);        //: µļ: 2015.05.18
            mCmdParam.Modify.mFileSize = 0xffffffff;                         // : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
            i = CH103FileModify();                                           //޸ĵǰļϢ,޸
            mStopIfError(i);
            printf("Close\r\n");
            mCmdParam.Close.mUpdateLen = 1;                                  //Զļ,ֽΪλдļ,óرļԱԶļ
            i = CH103FileClose();
            mStopIfError(i);

            /* ɾĳļļOLD.C ҪǰU̸Ŀ¼ */
            printf("Erase\r\n");
            strcpy((char *)mCmdParam.Create.mPathName, "/OLD.C");            //ҪɾļڸĿ¼
            i = CH103FileErase();                                            //ɾļر
            if(i != ERR_SUCCESS)
            {
                printf("Error: %02X\r\n", (uint16_t)i);                      //ʾϢûҵļ
                if(i == ERR_MISS_FILE)
                {
                    printf("Didn't file the file\r\n");
                }
            }
            else
            {
                printf("Erase Over\r\n");
            }
        }
        else
        {
            //ϣӵԭļβ,ƶļָ
            //дļ
            printf("ByteWrite\r\n");
            mCmdParam.ByteLocate.mByteOffset = 0xffffffff;                   //Ƶļβ
            CH103ByteLocate();
            //ʵӦждݳȺͶ建ǷڻҪд
            i = sprintf((char *)Com_Buffer, "Note: \xd\xaֽΪλUļд,ʾܡ\xd\xa");
            for(c = 0; c < 10; c++)
            {
                mCmdParam.ByteWrite.mByteCount = i;                          //ָдֽ
                mCmdParam.ByteWrite.mByteBuffer = Com_Buffer;                       //ָ򻺳
                s = CH103ByteWrite();                                        //ֽΪλļд
                mStopIfError(s);
                printf("WriteIn Success %02X times\r\n", (uint16_t)c);
            }

            //ȡļǰNֽ
            TotalCount = 60;                                                 //׼ȡܳ100ֽ
            printf("First %d characters read out:\r\n", TotalCount);
            while(TotalCount)                                                //ļȽϴ,һζ,ٵCH103ByteReadȡ,ļָԶƶ
            {
                if(TotalCount > (MAX_PATH_LEN - 1))
                {
                    c = MAX_PATH_LEN - 1;                                    //ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.Other.mBuffer ) */
                }
                else
                {
                    c = TotalCount;                                          //ʣֽ
                }
                mCmdParam.ByteRead.mByteCount = c;                           //ʮֽ
                mCmdParam.ByteRead.mByteBuffer = &Com_Buffer[0];
                s = CH103ByteRead();                                         //ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ
                TotalCount -= mCmdParam.ByteRead.mByteCount;                 //,ȥǰʵѾַ
                for(i = 0; i != mCmdParam.ByteRead.mByteCount; i++)
                {
                    printf("%c", mCmdParam.ByteRead.mByteBuffer[i]);         //ʾַ
                }
                if(mCmdParam.ByteRead.mByteCount < c)                        //ʵʶַҪַ,˵ѾļĽβ
                {
                    printf("\r\n");
                    printf("File end\r\n");
                    break;
                }
            }
            printf("Close\r\n");
            i = CH103FileClose();                                            //رļ
            mStopIfError(i);
        }
    }
}

/*********************************************************************
 * @fn      UDisk_USBH_SectorOperation
 *
 * @brief   Demo Function For UDisk File Sector-operation
 *          including Create\Modify\Read\Erase (EXAM6)
 *
 * @return  none
 */
void UDisk_USBH_SectorOperation( void )
{
    uint8_t  SecCount, s, i;
    uint16_t tmp;
    uint8_t  tmpbuf[64];

    UDisk_USBH_DiskReady( );
    if( ( CH103DiskStatus >= DISK_MOUNTED )&&( UDisk_Opeation_Flag == 1 ) )
    {
        UDisk_Opeation_Flag = 0;

#if DISK_BASE_BUF_LEN
        if(DISK_BASE_BUF_LEN < CH103vSectorSize)
        {
            /* ݻǷ㹻,CHRV3vSectorSizeU̵ʵС */
            printf("Too large sector size\n");
            return;
        }
#endif
        /* ȡԭļ */
        printf("Open\r\n");
        strcpy((char *)mCmdParam.Open.mPathName, "/C51/CHRV3HFT.C");    //ļ,ļC51Ŀ¼
        s = CH103FileOpen();                                           //ļ
        if(s == ERR_MISS_DIR || s == ERR_MISS_FILE)                    //ûҵļ
        {
            printf("ûҵļ\r\n");
        }
        else                                                           //ҵļ߳
        {
            printf("Query\r\n");
            i = CH103FileQuery();                                      //ѯǰļϢ
            mStopIfError(i);
            printf("Read\r\n");
            CH103vFileSize = CH103vFileSize + (sizeof(MY_DATA_BUF) - 1); //ԭļĳ
            SecCount = CH103vFileSize / sizeof(MY_DATA_BUF);          //ļ,ΪдΪλ,ȼCHRV3vSectorSize-1Ϊ˶ļβ1Ĳ
            printf("Size=%ld, Sec=%d\r\n", (long)CH103vFileSize, (uint16_t)SecCount);
            while(SecCount--)
            {
                mCmdParam.Read.mSectorCount = sizeof(MY_DATA_BUF) / 512; //ȡȫ,2ֻȡ2
                mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];            //ָļݻʼַ
                i = CH103FileRead();                                     //ļȡ
                mStopIfError(i);
                if(SecCount == 0) break;
//                for(tmp=0; tmp<sizeof( MY_DATA_BUF ); tmp++)
//                {
//                    printf("%02X ",(uint16_t)MY_DATA_BUF[tmp]);
//                }
//                printf("\n");
            }
            tmp = (CH103vFileSize - (sizeof(MY_DATA_BUF) - 1)) % sizeof(MY_DATA_BUF);
            if((tmp == 0) && (CH103vFileSize != 0)) tmp = sizeof(MY_DATA_BUF);
            CH103vFileSize = CH103vFileSize - (sizeof(MY_DATA_BUF) - 1);  //ָԭļĳ
//            for(i=0; i<tmp; i++)
//            {
//                printf("%02X ",(uint16_t)MY_DATA_BUF[i]);
//            }
//            printf("\n");

//            //ļȽϴ,һζ,ٵCHRV3FileReadȡ,ļָԶƶ
//            while ( 1 )
//            {
//                c = 4;   //ÿζȡ4,ԽһζȡԽ
//                mCmdParam.Read.mSectorCount = c;   //ָȡ
//                mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];  //ָļݻʼַ
//                CH103FileRead( );   //ļָԶ
//                //
//                if ( mCmdParam.Read.mSectorCount < c ) break;   //ʵʶС˵ļѾ
//            }
//            //ϣָλÿʼд,ƶļָ
//            mCmdParam.Locate.mSectorOffset = 3;  //ļǰ3ʼд
//            i = CH103FileLocate( );
//            mCmdParam.Read.mSectorCount = 10;
//            mCmdParam.Read.mDataBuffer = &MY_DATA_BUF[0];  //ָļݻʼַ
//            CH103FileRead( );  // ֱӶȡļĵ(CHRV3vSectorSizeH*256*3)ֽڿʼ,ǰ3
//            //ϣӵԭļβ,ƶļָ
//            i = CH103FileOpen( );
//            mCmdParam.Locate.mSectorOffset = 0xffffffff;  //Ƶļβ,Ϊλ,ԭļ3ֽ,CHRV3vSectorSizeHֽڴʼ
//            i = CH103FileLocate( );
//            mCmdParam.Write.mSectorCount = 10;
//            mCmdParam.Write.mDataBuffer = &MY_DATA_BUF[0];
//            CH103FileWrite( );   //ԭļĺ
//            //ʹCHRV3FileReadжݻʼַ
//            mCmdParam.Read.mSectorCount = 2;
//            mCmdParam.Read.mDataBuffer = 0x50;  //ݷŵ50HʼĻУҪָʼַ
//            CH103FileRead( );   //ļжȡ2ָ
//            //ʹCHRV3FileWriteжݻʼַ
//            mCmdParam.Write.mSectorCount = 2;
//            mCmdParam.Write.mDataBuffer = 0x50;  //50HʼĻед
//            CH103FileWrite( );   //ָед2ļ

            printf("Close\r\n");
            i = CH103FileClose();                                        //رļ
            mStopIfError(i);
        }
        printf("Create\r\n");
        strcpy((char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT");       //ļ,ڸĿ¼,ļ
        s = CH103FileCreate();                                           //½ļ,ļѾɾ½ */
        mStopIfError(s);
        printf("Write\r\n");
        strcpy((char *)tmpbuf, "000ABCDEFGHIJKLMNOPQRSTUVWXYZ\xd\xa");    //׼дļ
        for(i = 0; i < (DISK_BASE_BUF_LEN / sizeof(tmpbuf)); i++)
        {
            tmp = i * sizeof(tmpbuf);
            strcpy((char *)&MY_DATA_BUF[tmp], (char *)tmpbuf);
        }
        for(tmp = 0; tmp < sizeof(MY_DATA_BUF); tmp++)
        {
            printf("%02X", (uint16_t)MY_DATA_BUF[tmp]);
        }
        printf("\r\n");
        for(s = 0; s < 10; s++)
        {
            mCmdParam.Write.mSectorCount = 1;                 //д
            mCmdParam.Write.mDataBuffer = &MY_DATA_BUF[0];    //ָļݻʼַ
            i = CH103FileWrite();                             //ļд
            mStopIfError(i);
            printf("ɹд %02X\r\n", (uint16_t)s);
        }
//        printf( "Modify\n" );
//        mCmdParam.Modify.mFileAttr = 0xff;                           //: µļ,Ϊ0FFH޸
//        mCmdParam.Modify.mFileTime = 0xffff;                         //: µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
//        mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2015, 5, 18 );  //: µļ: 2015.05.18
//        mCmdParam.Modify.mFileSize = 0xffffffff;                     //: µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
//        i = CH103FileModify( );                                      //޸ĵǰļϢ,޸
//        mStopIfError( i );
        printf("Close\r\n");
        mCmdParam.Close.mUpdateLen = 1;                                    //Զļ,ֽΪλдļ,óرļԱԶļ
        i = CH103FileClose();
//        mStopIfError(i);
//        /* Delete a fileAn OLD.C file needs to be prepared in advance in the root directory of the USB Disk. */
//        /* ɾĳļļOLD.C ҪǰU̸Ŀ¼ */
//        printf( "Erase\r\n" );
//        strcpy( (char *)mCmdParam.Create.mPathName, "/OLD.C" );       //file to be delated, under root directory.//ҪɾļڸĿ¼
//        i = CH103FileErase( );                                       //delate a file and close//ɾļر
//        if ( i != ERR_SUCCESS )
//        {
//            printf( "Error: %02X\r\n", (uint16_t)i );                  //Display ERR Info , can be not found a file.//ʾϢûҵļ
//            if( i == ERR_MISS_FILE )
//            {
//                printf( "Didn't file the file\r\n" );
//            }
//        }
//        else
//        {
//            printf( "Erase Over\r\n" );
//        }
    }
}


/*********************************************************************
 * @fn      UDisk_USBH_EnumFiles
 *
 * @brief   Demo Function For Enumerating files in UDisk(EXAM11)
 *
 * @return  none
 */
void UDisk_USBH_EnumFiles( void )
{
    uint8_t  i, s;
    uint16_t j;

    UDisk_USBH_DiskReady( );
    if( ( CH103DiskStatus >= DISK_MOUNTED )&&( UDisk_Opeation_Flag == 1 ) )
    {
        UDisk_Opeation_Flag = 0;
        /* ȡԭļ */
        printf( "Open\r\n" );
        strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CHRV3HFT.C" );//ļ,ļC51Ŀ¼
        s = CH103FileOpen( );                        //ļ
        /* гļ */
        if ( s == ERR_MISS_DIR )
        {
            printf("ڸļгļ\r\n");  //C51Ŀ¼гĿ¼µļ
            pCodeStr = (uint8_t *)"/*";
        }
        else
        {
            pCodeStr = (uint8_t *)"/C51/*";                     //CHRV3HFT.Cļг\C51Ŀ¼µCHRV3ͷļ
        }
        printf( "List file %s\r\n", pCodeStr );
        for ( j = 0; j < 10000; j ++ )               //ǰ10000ļ,ʵû
        {
            strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );//ļ,*Ϊͨ,ļĿ¼
            i = strlen( (char *)mCmdParam.Open.mPathName );
            mCmdParam.Open.mPathName[ i ] = 0xFF;    //ַȽ滻Ϊ,0254,0xFF255˵CHRV3vFileSize
            CH103vFileSize = j;                      //ָ/öٵ
            i = CH103FileOpen( );                    //ļ,ļкͨ*,Ϊļ
            /* CHRV3FileEnum  CHRV3FileOpen Ψһǵ߷ERR_FOUND_NAMEʱôӦǰ߷ERR_SUCCESS */
            if ( i == ERR_MISS_FILE )
            {
                break;                                //Ҳƥļ,Ѿûƥļ
            }
            if ( i == ERR_FOUND_NAME )
            {
                /* ͨƥļ,ļ· */
                printf( "  match file %04d#: %s\r\n", (unsigned int)j, mCmdParam.Open.mPathName );//ʾźƥļĿ¼
                continue;                             //һƥļ,´ʱŻ1
            }
            else
            {
                /*  */
                mStopIfError( i );
                break;
            }
        }
        printf( "Close\r\n" );
        CH103FileClose( );                            //رļ
        printf( "Uʾ\r\n" );
    }
}
